'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _RESET__, _labels;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _SinglePageModal = require('./SinglePageModal');

var _SinglePageModal2 = _interopRequireDefault(_SinglePageModal);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _SignInWithEmailAndPasswordForm = require('./SignInWithEmailAndPasswordForm');

var _SignInWithEmailAndPasswordForm2 = _interopRequireDefault(_SignInWithEmailAndPasswordForm);

var _CreateUserWithEmailAndPasswordForm = require('./CreateUserWithEmailAndPasswordForm');

var _CreateUserWithEmailAndPasswordForm2 = _interopRequireDefault(_CreateUserWithEmailAndPasswordForm);

var _SendPasswordResetEmailForm = require('./SendPasswordResetEmailForm');

var _SendPasswordResetEmailForm2 = _interopRequireDefault(_SendPasswordResetEmailForm);

var _SendEmailVerificationForm = require('./SendEmailVerificationForm');

var _SendEmailVerificationForm2 = _interopRequireDefault(_SendEmailVerificationForm);

var _LoginViaThirdParty = require('./LoginViaThirdParty');

var _LoginViaThirdParty2 = _interopRequireDefault(_LoginViaThirdParty);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __CREATE__ = _constants.auth.__CREATE__,
    __SIGNIN__ = _constants.auth.__SIGNIN__,
    __VERIFY__ = _constants.auth.__VERIFY__,
    __RESET__ = _constants.auth.__RESET__;


var AuthModal = function AuthModal(_ref) {
  var handleSignInWithEmailAndPassword = _ref.handleSignInWithEmailAndPassword,
      handleCreateUserWithEmailAndPassword = _ref.handleCreateUserWithEmailAndPassword,
      handleSendEmailVerification = _ref.handleSendEmailVerification,
      handleSendPasswordResetEmail = _ref.handleSendPasswordResetEmail,
      handleSignInWithFacebook = _ref.handleSignInWithFacebook,
      handleSignInWithGoogle = _ref.handleSignInWithGoogle,
      labels = _ref.labels,
      setModeTo = _ref.setModeTo,
      _ref$initialMode = _ref.initialMode,
      initialMode = _ref$initialMode === undefined ? __SIGNIN__ : _ref$initialMode,
      mode = _ref.mode,
      props = (0, _objectWithoutProperties3.default)(_ref, ['handleSignInWithEmailAndPassword', 'handleCreateUserWithEmailAndPassword', 'handleSendEmailVerification', 'handleSendPasswordResetEmail', 'handleSignInWithFacebook', 'handleSignInWithGoogle', 'labels', 'setModeTo', 'initialMode', 'mode']);

  var Divider = function Divider(_ref2) {
    var children = _ref2.children;
    return _react2.default.createElement(
      'div',
      {
        style: {
          display: 'flex',
          margin: '1rem 0',
          alignItems: 'center'
        }
      },
      _react2.default.createElement('div', { style: { backgroundColor: '#ccc', flexGrow: 3, height: '3px' } }),
      _react2.default.createElement(
        'div',
        { style: { flexGrow: 1, textAlign: 'center' } },
        children
      ),
      _react2.default.createElement('div', { style: { backgroundColor: '#ccc', flexGrow: 3, height: '3px' } })
    );
  };
  var TPAuth = function TPAuth() {
    return _react2.default.createElement(_LoginViaThirdParty2.default, { handleSignInWithFacebook: handleSignInWithFacebook, handleSignInWithGoogle: handleSignInWithGoogle, labels: labels.thirdparty });
  };
  var auxProps = {
    className: 'authmodal__auxbuttons',
    style: { display: 'flex', flexDirection: 'column', justifyContent: 'center' }
  };
  var renderAuxButton = function renderAuxButton(newMode) {
    return _react2.default.createElement(
      _Button2.default,
      {
        onClick: function onClick() {
          return setModeTo(newMode);
        },
        colors: 'link',
        style: { textAlign: 'center' }
      },
      labels[newMode].subTrigger
    );
  };
  var renderLinks = function renderLinks() {
    switch (mode) {
      case __SIGNIN__:
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, auxProps),
          renderAuxButton(__CREATE__),
          renderAuxButton(__RESET__)
        );
      case __CREATE__:
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, auxProps),
          renderAuxButton(__SIGNIN__),
          renderAuxButton(__VERIFY__)
        );
      case __VERIFY__:
        return null;
      //(
      //  <div
      //    {...{
      //      ...auxProps,
      //    }}
      //  >
      //    {renderAuxButton(__CREATE__)}
      //  </div>
      //)
      case __RESET__:
        return null;
      //(
      //  <div
      //    {...{
      //      ...auxProps,
      //    }}
      //  >
      //    {renderAuxButton(__SIGNIN__)}
      //  </div>
      //)
      default:
        break;
    }
  };
  var renderTPAuth = function renderTPAuth() {
    switch (mode) {
      case __SIGNIN__:
        return _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(
            Divider,
            null,
            'OR'
          ),
          _react2.default.createElement(TPAuth, null)
        );
      case __CREATE__:
        return _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(
            Divider,
            null,
            'OR'
          ),
          _react2.default.createElement(TPAuth, null)
        );
      case __VERIFY__:
        return null;
      case __RESET__:
        return null;
      default:
        break;
    }
  };

  var renderForm = function renderForm() {
    switch (mode) {
      case __SIGNIN__:
        return _react2.default.createElement(_SignInWithEmailAndPasswordForm2.default, { handleSignInWithEmailAndPassword: handleSignInWithEmailAndPassword, labels: labels[mode] });
      case __CREATE__:
        return _react2.default.createElement(_CreateUserWithEmailAndPasswordForm2.default, { handleCreateUserWithEmailAndPassword: handleCreateUserWithEmailAndPassword, labels: labels[mode] });
      case __VERIFY__:
        return _react2.default.createElement(_SendEmailVerificationForm2.default, { handleSendEmailVerification: handleSendEmailVerification, labels: labels[mode] });
      case __RESET__:
        return _react2.default.createElement(_SendPasswordResetEmailForm2.default, { handleSendPasswordResetEmail: handleSendPasswordResetEmail, labels: labels[mode] });
      default:
        break;
    }
  };
  return _react2.default.createElement(_SinglePageModal2.default, (0, _extends3.default)({
    onCloseModal: function onCloseModal() {
      setModeTo(initialMode);
    },
    className: 'authmodal__container',
    style: { width: '30rem' },
    dataTestId: 'authmodal-container',
    renderTrigger: function renderTrigger(_ref3) {
      var getTriggerProps = _ref3.getTriggerProps;
      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({}, getTriggerProps({ className: 'authmodal__trigger' })),
        labels[initialMode].trigger
      );
    },
    renderHeader: function renderHeader(_ref4) {
      var getHeaderProps = _ref4.getHeaderProps;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getHeaderProps({ className: 'authmodal__header' })),
        labels[mode].header
      );
    },
    renderBody: function renderBody(_ref5) {
      var getBodyProps = _ref5.getBodyProps;
      return _react2.default.createElement(
        'div',
        getBodyProps({ className: 'authmodal__body' }),
        renderForm(),
        renderLinks(),
        renderTPAuth()
      );
    }
  }, props));
};

AuthModal.propTypes = {};
AuthModal.defaultProps = {
  handleCreateUserWithEmailAndPassword: function handleCreateUserWithEmailAndPassword(_ref6) {
    var email = _ref6.email,
        password = _ref6.password;
    return console.log('handleCreateUserWithEmailAndPassword', email, password);
  },
  handleSignInWithEmailAndPassword: function handleSignInWithEmailAndPassword(_ref7) {
    var email = _ref7.email,
        password = _ref7.password;
    return console.log('handleSignInWithEmailAndPassword', email, password);
  },
  handleSendPasswordResetEmail: function handleSendPasswordResetEmail(email) {
    return console.log('handleSendPasswordResetEmail', email);
  },
  handleSendEmailVerification: function handleSendEmailVerification(email) {
    return console.log('handleSendEmailVerification', email);
  },
  handleSignInWithFacebook: function handleSignInWithFacebook() {
    return console.log('handleSignInWithFacebook');
  },
  handleSignInWithGoogle: function handleSignInWithGoogle() {
    return console.log('handleSignInWithGoogle');
  },
  labels: (_labels = {}, (0, _defineProperty3.default)(_labels, __CREATE__, {
    header: 'Register a new account',
    trigger: 'register',
    subTrigger: 'Don\'t have an account? Create one ',
    submit: 'submit',
    email: 'email',
    emailRequired: 'emailRequired',
    emailInvalid: 'emailInvalid',
    password: 'password',
    passwordRequired: 'passwordRequired',
    passwordMinLength: 'passwordMinLength',
    passwordConfirmation: 'passwordConfirmation',
    passwordConfirmationRequired: 'passwordConfirmationRequired',
    passwordConfirmationMismatch: 'passwordConfirmationMismatch'
  }), (0, _defineProperty3.default)(_labels, __SIGNIN__, {
    header: 'Sign in',
    trigger: 'signin',
    subTrigger: 'Already have an account? Sign in',
    password: 'Password',
    email: 'Email',
    emailInvalid: 'emailInvalid',
    emailRequired: 'emailRequired',
    submit: 'Submit',
    passwordRequired: 'passwordRequired',
    passwordMinLength: 'passwordMinLength'
  }), (0, _defineProperty3.default)(_labels, __RESET__, (_RESET__ = {
    subTrigger: 'Forgot your password?',
    trigger: 'recover your password',
    header: 'Recover your password',
    email: 'enter your email'
  }, (0, _defineProperty3.default)(_RESET__, 'email', 'Email'), (0, _defineProperty3.default)(_RESET__, 'emailInvalid', 'emailInvalid'), (0, _defineProperty3.default)(_RESET__, 'emailRequired', 'emailRequired'), (0, _defineProperty3.default)(_RESET__, 'submit', 'submit'), _RESET__)), (0, _defineProperty3.default)(_labels, __VERIFY__, {
    subTrigger: 'Did not receive verification email? Let us send it again',
    trigger: 'Resend verification email',
    header: 'Resend verification email',
    email: 'Email',
    emailInvalid: 'emailInvalid',
    emailRequired: 'emailRequired',
    submit: 'submit'
  }), (0, _defineProperty3.default)(_labels, 'thirdparty', {
    signinwithfacebook: 'sign in with facebook',
    signinwithgoogle: 'sign in with google'
  }), _labels)
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('mode', 'setModeTo', function (_ref8) {
  var initialMode = _ref8.initialMode;
  return initialMode;
}));

exports.default = enhance(AuthModal);