'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _CTCGeneric = require('./CTCGeneric');

var _CTCGeneric2 = _interopRequireDefault(_CTCGeneric);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CTCPopover = function CTCPopover(_ref) {
  var _ref$transitionType = _ref.transitionType,
      transitionType = _ref$transitionType === undefined ? 'fade' : _ref$transitionType,
      _ref$OCListener = _ref.OCListener,
      OCListener = _ref$OCListener === undefined ? true : _ref$OCListener,
      children = _ref.children,
      transitionProps = _ref.transitionProps,
      debugMode = _ref.debugMode,
      renderTrigger = _ref.renderTrigger,
      _ref$className = _ref.className,
      className = _ref$className === undefined ? '' : _ref$className,
      _ref$style = _ref.style,
      style = _ref$style === undefined ? {} : _ref$style,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === undefined ? function () {
    return null;
  } : _ref$onClick,
      props = (0, _objectWithoutProperties3.default)(_ref, ['transitionType', 'OCListener', 'children', 'transitionProps', 'debugMode', 'renderTrigger', 'className', 'style', 'onClick']);

  return _react2.default.createElement(
    _CTCGeneric2.default,
    (0, _extends3.default)({}, props, { OCListener: OCListener }),
    function (_ref2) {
      var _getChildrenProps = _ref2.getChildrenProps,
          OCListenerRef = _ref2.OCListenerRef,
          getContainerProps = _ref2.getContainerProps,
          _getTriggerProps = _ref2.getTriggerProps,
          isOn = _ref2.isOn,
          setIsOnTo = _ref2.setIsOnTo,
          toggleIsOn = _ref2.toggleIsOn;
      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({
          ref: OCListenerRef
        }, getContainerProps({
          className: (0, _helperFunctions.flippyClass)(isOn, 'ctcdropdown__container', 'show', 'hide') + ' ' + className,
          style: style,
          onClick: onClick
        })),
        renderTrigger({
          isOn: isOn,
          setIsOnTo: setIsOnTo,
          toggleIsOn: toggleIsOn,
          getTriggerProps: function getTriggerProps() {
            var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var _ref3$className = _ref3.className,
                className = _ref3$className === undefined ? '' : _ref3$className,
                props = (0, _objectWithoutProperties3.default)(_ref3, ['className']);
            return _getTriggerProps((0, _extends3.default)({
              className: (0, _helperFunctions.flippyClass)(isOn, 'ctcdropdown__trigger', 'show', 'hide') + ' ' + className
            }, props));
          }
        }),
        _react2.default.createElement(
          _RTGTransition2.default,
          {
            transitionType: transitionType,
            in: debugMode && debugMode.alwaysOn ? true : isOn,
            transitionProps: transitionProps
          },
          function (_ref4) {
            var transitionStyle = _ref4.style;
            return typeof children === 'function' ? children({
              getChildrenProps: function getChildrenProps() {
                var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                var _ref5$className = _ref5.className,
                    className = _ref5$className === undefined ? '' : _ref5$className,
                    _ref5$style = _ref5.style,
                    style = _ref5$style === undefined ? {} : _ref5$style,
                    props = (0, _objectWithoutProperties3.default)(_ref5, ['className', 'style']);
                return _getChildrenProps((0, _extends3.default)({
                  className: (0, _helperFunctions.flippyClass)(isOn, 'ctcdropdown__children', 'show', 'hide') + ' ' + className,
                  style: (0, _extends3.default)({}, transitionStyle, style)
                }, props));
              },
              isOn: isOn,
              setIsOnTo: setIsOnTo,
              toggleIsOn: toggleIsOn
            }) : _react2.default.createElement(
              'div',
              (0, _extends3.default)({}, _getChildrenProps({ style: transitionStyle })),
              children
            );
          }
        )
      );
    }
  );
};

CTCPopover.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]).isRequired,
  renderTrigger: _propTypes2.default.func.isRequired
};

CTCPopover.defaultProps = {
  isOn: false
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children']));

exports.default = enhance(CTCPopover);