'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconSize = '50';
var scrollOptions = { block: 'start', behavior: 'smooth' };

var ContainerNav = function (_Component) {
  (0, _inherits3.default)(ContainerNav, _Component);

  function ContainerNav() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ContainerNav);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ContainerNav.__proto__ || (0, _getPrototypeOf2.default)(ContainerNav)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showContainerNav: false
    }, _this.handleScroll = function () {
      var containerId = _this.props.containerId;

      var container = document.getElementById(containerId);
      if (container.offsetTop < window.scrollY && container.offsetTop + container.offsetHeight > window.scrollY + window.screen.height) {
        _this.setState((0, _extends4.default)({}, _this.state, { showContainerNav: true }));
      }
      if (container.offsetTop > window.scrollY || container.offsetTop + container.offsetHeight < window.scrollY + window.screen.height) {
        _this.setState((0, _extends4.default)({}, _this.state, { showContainerNav: false }));
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ContainerNav, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window ? window.addEventListener('scroll', this.handleScroll) : null;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.handleScroll);
    }
  }, {
    key: 'render',
    value: function render() {
      var showContainerNav = this.state.showContainerNav,
          _props = this.props,
          containerId = _props.containerId,
          children = _props.children;

      var sharedStyle = {
        position: 'fixed',
        left: '2rem'
      };
      var container = document.getElementById(containerId);
      var renderIcon = function renderIcon(_ref2) {
        var direction = _ref2.direction,
            props = (0, _objectWithoutProperties3.default)(_ref2, ['direction']);
        return direction === 'top' ? _react2.default.createElement(_SVGExpandLess2.default, (0, _extends4.default)({}, props)) : _react2.default.createElement(_SVGExpandMore2.default, (0, _extends4.default)({}, props));
      };
      return _react2.default.createElement(
        _RTGTransition2.default,
        { transitionType: 'fade', duration: 1000, in: showContainerNav },
        function (_ref3) {
          var transitionStyle = _ref3.style;

          var getAllWayProps = function getAllWayProps() {
            var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'top';
            return function () {
              var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              var _onClick = _ref4.onClick,
                  className = _ref4.className,
                  style = _ref4.style,
                  props = (0, _objectWithoutProperties3.default)(_ref4, ['onClick', 'className', 'style']);
              return (0, _extends4.default)({
                onClick: function onClick(e) {
                  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                    args[_key2 - 1] = arguments[_key2];
                  }

                  e.stopPropagation();
                  direction === 'top' ? container.scrollIntoView(scrollOptions) : container.scrollIntoView((0, _extends4.default)({}, scrollOptions, {
                    block: 'end'
                  })), _onClick && _onClick.apply(undefined, [e].concat(args));
                },
                className: (0, _helperFunctions.flippyClass)(showContainerNav, 'ContainerNav__allway', 'show', 'hide') + ' ' + (0, _helperFunctions.flippyClass)(showContainerNav, 'ContainerNav__allway__' + direction, 'show', 'hide'),
                style: (0, _extends4.default)({}, sharedStyle, transitionStyle, (0, _defineProperty3.default)({}, direction, '2rem'), style)
              }, props);
            };
          };
          return typeof children === 'function' ? children({ getAllWayProps: getAllWayProps, renderIcon: renderIcon }) : _react2.default.createElement(
            _react2.default.Fragment,
            null,
            _react2.default.createElement(
              _Button2.default,
              (0, _extends4.default)({}, getAllWayProps('top')()),
              renderIcon({ direction: 'top', size: iconSize })
            ),
            _react2.default.createElement(
              _Button2.default,
              (0, _extends4.default)({}, getAllWayProps('bottom')()),
              renderIcon({ direction: 'bottom', size: iconSize })
            )
          );
        }
      );
    }
  }]);
  return ContainerNav;
}(_react.Component);

exports.default = ContainerNav;