'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _SVGMenu = require('./svg/SVGMenu');

var _SVGMenu2 = _interopRequireDefault(_SVGMenu);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _defaultStyles = require('./defaultStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HorizontalMenu = function HorizontalMenu(_ref) {
  var children = _ref.children,
      renderHorizontal = _ref.renderHorizontal;
  return _react2.default.createElement(
    'div',
    {
      style: {
        display: 'flex'
      },
      className: 'flexiblemenu__menu--horizontal'
    },
    renderHorizontal ? renderHorizontal() : children
  );
};

var DropdownMenu = function DropdownMenu(_ref2) {
  var children = _ref2.children,
      pivotFrom = _ref2.pivotFrom,
      _renderTrigger = _ref2.renderTrigger,
      debugMode = _ref2.debugMode;

  var triggerBaseClassName = 'flexiblemenu__trigger';
  var defaultRenderTrigger = function defaultRenderTrigger(_ref3) {
    var getTriggerProps = _ref3.getTriggerProps,
        isOn = _ref3.isOn;
    return _react2.default.createElement(
      _Button2.default,
      { type: 'menutoggle', isOn: isOn, colors: _defaultStyles.buttonStyles.vampire },
      function (_ref4) {
        var getButtonProps = _ref4.getButtonProps;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({}, getTriggerProps({ className: triggerBaseClassName })))),
          _react2.default.createElement(_SVGMenu2.default, null)
        );
      }
    );
  };
  return _react2.default.createElement(
    'div',
    { className: 'flexiblemenu__menu--dropdown', style: { position: 'relative' } },
    _react2.default.createElement(
      _CTCPopover2.default,
      {
        debugMode: debugMode,
        pivotFrom: pivotFrom,
        renderTrigger: function renderTrigger(_ref5) {
          var _getTriggerProps = _ref5.getTriggerProps,
              isOn = _ref5.isOn;
          return _renderTrigger ? _renderTrigger({
            getTriggerProps: function getTriggerProps() {
              var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              var className = _ref6.className,
                  props = (0, _objectWithoutProperties3.default)(_ref6, ['className']);
              return _getTriggerProps((0, _extends3.default)({
                className: triggerBaseClassName + ' ' + (className ? className : '')
              }, props));
            },
            isOn: isOn
          }) : defaultRenderTrigger({ getTriggerProps: _getTriggerProps, isOn: isOn });
        }
      },
      children
    )
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  showHorizontal: true
}), (0, _recompose.branch)(function (_ref7) {
  var isHorizontal = _ref7.isHorizontal,
      showHorizontal = _ref7.showHorizontal;
  return showHorizontal && isHorizontal;
}, (0, _recompose.renderComponent)(HorizontalMenu), (0, _recompose.renderComponent)((0, _recompose.compose)((0, _recompose.branch)(function (_ref8) {
  var isHorizontal = _ref8.isHorizontal;
  return !isHorizontal;
}, (0, _recompose.renderComponent)(DropdownMenu), _recompose.renderNothing)(DropdownMenu)))), (0, _recompose.onlyUpdateForKeys)(['children', 'pivotFrom', 'isHorizontal']));
exports.default = enhance(HorizontalMenu);