'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _helperFunctions = require('./helperFunctions');

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _reactMediumImageZoom = require('react-medium-image-zoom');

var _reactMediumImageZoom2 = _interopRequireDefault(_reactMediumImageZoom);

var _OutsideClickListener = require('./OutsideClickListener');

var _OutsideClickListener2 = _interopRequireDefault(_OutsideClickListener);

var _Accordion = require('./Accordion');

var _Accordion2 = _interopRequireDefault(_Accordion);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _defaultStyles = require('./defaultStyles');

var _PointerUser = require('./PointerUser');

var _PointerUser2 = _interopRequireDefault(_PointerUser);

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

var _recompose = require('recompose');

var _KBListener = require('./KBListener');

var _KBListener2 = _interopRequireDefault(_KBListener);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//gradual image transitions

var ImageViewer = function (_Component) {
  (0, _inherits3.default)(ImageViewer, _Component);

  function ImageViewer() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ImageViewer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ImageViewer.__proto__ || (0, _getPrototypeOf2.default)(ImageViewer)).call.apply(_ref, [this].concat(args))), _this), _this.componentDidUpdate = function (prevProps) {
      var _this$props = _this.props,
          srcs = _this$props.srcs,
          updateState = _this$props.updateState;

      if (prevProps.srcs !== srcs) {
        updateState({ activeSrc: srcs[0] });
      }
    }, _this.setSrc = function (target) {
      var _this2 = _this,
          accordionRef = _this2.accordionRef,
          _this2$props = _this2.props,
          srcs = _this2$props.srcs,
          activeSrc = _this2$props.state.activeSrc,
          updateState = _this2$props.updateState;

      var index = srcs.indexOf(activeSrc);
      if (target === 'prev') {
        if (index === 0) {
          updateState({ activeSrc: srcs[srcs.length - 1] });
          accordionRef.current.scrollLeft = accordionRef.current.getBoundingClientRect().width;
        } else {
          updateState({ activeSrc: srcs[index - 1] });
          //console.log(accordionRef.current.scrollLeft)
          accordionRef.current.scrollLeft -= 50;
        }
      }
      if (target === 'next') {
        if (index === srcs.length - 1) {
          updateState({ activeSrc: srcs[0] });
          accordionRef.current.scrollLeft = 0;
        } else {
          updateState({ activeSrc: srcs[index + 1] });
          //console.log(accordionRef.current.scrollLeft)
          accordionRef.current.scrollLeft += 50;
        }
      }
    }, _this.accordionRef = _react2.default.createRef(), _this.containerRef = _react2.default.createRef(), _this.imageFrameRef = _react2.default.createRef(), _this.getSharedTopButtonStyle = function () {
      var _this$props2 = _this.props,
          frameWidth = _this$props2.frameWidth,
          itemWidth = _this$props2.itemWidth,
          srcs = _this$props2.srcs,
          noButtons = _this$props2.noButtons;
      //const height =
      //  this.imageFrameRef.current && this.imageFrameRef.current.getBoundingClientRect().height

      return {
        display: noButtons ? 'none' : srcs.length * itemWidth > frameWidth ? 'flex' : 'none',
        position: 'absolute',
        top: 0,
        padding: 0,
        zIndex: 1,
        height: '100%'
      };
    }, _this.getSharedBottomButtonStyle = function () {
      var _this$props3 = _this.props,
          frameWidth = _this$props3.frameWidth,
          itemWidth = _this$props3.itemWidth,
          srcs = _this$props3.srcs,
          noButtons = _this$props3.noButtons;
      //const height =
      //  this.imageFrameRef.current && this.imageFrameRef.current.getBoundingClientRect().height

      return {
        display: noButtons ? 'none' : srcs.length * itemWidth > frameWidth ? 'none' : 'flex',
        height: '2.5rem',
        width: '2.5rem',
        margin: '0 1.75rem',
        border: '1px solid white',
        padding: '1rem',
        zIndex: 1
      };
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ImageViewer, [{
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          swipeableProps = _props.swipeableProps,
          layout = _props.layout,
          _props$state = _props.state,
          isActive = _props$state.isActive,
          activeSrc = _props$state.activeSrc,
          className = _props.className,
          style = _props.style,
          onClick = _props.onClick,
          updateState = _props.updateState,
          srcs = _props.srcs,
          cssImageZoomedOutClass = _props.cssImageZoomedOutClass,
          cssImageZoomedInClass = _props.cssImageZoomedInClass,
          zoomedOutImageProps = _props.zoomedOutImageProps,
          zoomedInImageProps = _props.zoomedInImageProps,
          renderTopRight = _props.renderTopRight,
          frameHeight = _props.frameHeight,
          frameWidth = _props.frameWidth,
          itemWidth = _props.itemWidth,
          itemHeight = _props.itemHeight,
          renderMidArea = _props.renderMidArea,
          renderOption = _props.renderOption,
          renderOptions = _props.renderOptions,
          setSrc = this.setSrc,
          imageFrameRef = this.imageFrameRef,
          getSharedTopButtonStyle = this.getSharedTopButtonStyle,
          getSharedBottomButtonStyle = this.getSharedBottomButtonStyle;

      var getOptionProps = function getOptionProps(src, i) {
        return function () {
          var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          var className = _ref2.className,
              style = _ref2.style,
              _onClick = _ref2.onClick,
              props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick']);
          return (0, _extends3.default)({
            style: (0, _extends3.default)({
              backgroundImage: 'url(\'' + src + '\')',
              backgroundPosition: 'center',
              backgroundSize: 'cover',
              backgroundRepeat: 'no-repeat',
              height: '10rem',
              cursor: 'pointer'
            }, style),
            key: i,
            onClick: function onClick(e) {
              for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
              }

              _onClick && _onClick.apply(undefined, [e].concat(args));
              updateState({ activeSrc: src });
            },
            className: className ? (0, _helperFunctions.flippyClass)(src === activeSrc, 'imageviewer__preview__item', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(src === activeSrc, className, 'active', 'inactive') : (0, _helperFunctions.flippyClass)(src === activeSrc, 'imageviewer__preview__item', 'active', 'inactive')
          }, props);
        };
      };
      return _react2.default.createElement(
        _KBListener2.default,
        {
          onKBLeftArrow: function onKBLeftArrow() {
            if (isActive) {
              setSrc('prev');
            }
          },
          onKBRightArrow: function onKBRightArrow() {
            if (isActive) {
              setSrc('next');
            }
          }
        },
        _react2.default.createElement(
          _OutsideClickListener2.default,
          {
            containerRef: this.containerRef,
            handler: function handler() {
              return updateState({ isActive: false });
            },
            insideHandler: function insideHandler() {
              return updateState({ isActive: true });
            }
          },
          _react2.default.createElement(
            'div',
            {
              onClick: onClick,
              className: className ? className + ' imageviewer__container' : 'imageviewer__container',
              ref: this.containerRef,
              style: (0, _extends3.default)({
                display: 'flex',
                flexDirection: layout === 'vertical' ? 'row' : 'column',
                alignItems: 'center',
                justifyContent: 'center'
              }, style)
            },
            _react2.default.createElement(
              'div',
              {
                className: 'imageviewer__imagewrapper',
                style: { display: 'flex', alignItems: 'center' }
              },
              _react2.default.createElement(
                'div',
                {
                  className: 'imageviewer__imageframe',
                  ref: imageFrameRef,
                  style: {
                    position: 'relative',
                    display: 'flex',
                    justifyContent: 'center'
                    //width: frameWidth,
                    //height: frameHeight,
                  }
                },
                _react2.default.createElement(
                  _Button2.default,
                  {
                    onClick: function onClick() {
                      return _this3.setSrc('prev');
                    },
                    colors: _defaultStyles.buttonStyles.transparentNeutral,
                    style: (0, _extends3.default)({}, getSharedTopButtonStyle(), { left: -24 })
                  },
                  _react2.default.createElement(_SVGPrev2.default, { size: '24', fill: '#666666' })
                ),
                _react2.default.createElement(
                  _reactSwipeable2.default,
                  {
                    onSwipedLeft: function onSwipedLeft(e, absX) {
                      _this3.setSrc('prev');
                    },
                    onSwipedRight: function onSwipedRight(e, absX) {
                      _this3.setSrc('next');
                    },
                    className: 'imageviewer__image',
                    style: {
                      display: 'flex',
                      alignItems: 'center',
                      justifyContent: 'center'
                    }
                  },
                  _react2.default.createElement(_reactMediumImageZoom2.default, {
                    image: (0, _extends3.default)({
                      src: activeSrc,
                      className: cssImageZoomedOutClass
                    }, zoomedOutImageProps),
                    zoomImage: (0, _extends3.default)({
                      src: activeSrc,
                      className: cssImageZoomedInClass
                    }, zoomedInImageProps)
                  })
                ),
                _react2.default.createElement(
                  _Button2.default,
                  {
                    onClick: function onClick() {
                      return _this3.setSrc('next');
                    },
                    colors: _defaultStyles.buttonStyles.transparentNeutral,
                    style: (0, _extends3.default)({}, getSharedTopButtonStyle(), { right: -24 })
                  },
                  _react2.default.createElement(_SVGNext2.default, { size: '24', fill: '#666666' })
                )
              )
            ),
            renderMidArea && renderMidArea(),
            renderOptions ? renderOptions({ getOptionProps: getOptionProps, srcs: srcs, activeSrc: activeSrc }) : _react2.default.createElement(
              'div',
              {
                style: { position: 'relative', display: 'flex' },
                className: 'imageviewer__preview__container'
              },
              _react2.default.createElement(
                _Button2.default,
                {
                  onClick: function onClick() {
                    return _this3.setSrc('prev');
                  },
                  colors: _defaultStyles.buttonStyles.transparentNeutral,
                  style: (0, _extends3.default)({}, getSharedBottomButtonStyle())
                },
                _react2.default.createElement(_SVGPrev2.default, { size: '24', fill: '#666666' })
              ),
              _react2.default.createElement(
                _Accordion2.default,
                {
                  swipeableProps: {
                    style: {
                      overflow: 'hidden',
                      display: 'flex',

                      flexDirection: layout === 'vertical' ? 'column' : 'row',
                      width: layout === 'vertical' ? null : srcs.length * itemWidth > frameWidth ? frameWidth : srcs.length * itemWidth,
                      height: layout === 'vertical' ? srcs.length * itemHeight > frameHeight ? frameHeight : srcs.length * itemHeight : null
                    },
                    className: 'imageviewer__preview__items'
                  }
                },
                srcs.map(function (src, i) {
                  return renderOption ? renderOption({
                    getOptionProps: getOptionProps(src, i),
                    isActive: activeSrc === src
                  }) : _react2.default.createElement(_Button2.default, (0, _extends3.default)({
                    isOn: src === activeSrc,
                    colors: {
                      transition: 'smooth',
                      on: { backgroundColor: '#eeea' },
                      off: { backgroundColor: '#3333' },
                      disabled: { backgroundColor: '#ccc', color: '#888' },
                      diff: 30
                    }
                  }, getOptionProps(src, i)({
                    style: {
                      backgroundSize: 'auto 90%',
                      minWidth: '4rem',
                      minHeight: '8rem'
                    }
                  })));
                })
              ),
              _react2.default.createElement(
                _Button2.default,
                {
                  onClick: function onClick() {
                    return _this3.setSrc('next');
                  },
                  colors: _defaultStyles.buttonStyles.transparentNeutral,
                  style: (0, _extends3.default)({}, getSharedBottomButtonStyle())
                },
                _react2.default.createElement(_SVGNext2.default, { size: '24', fill: '#666666' })
              )
            )
          )
        )
      );
    }
  }]);
  return ImageViewer;
}(_react.Component);

ImageViewer.propTypes = {
  srcs: _propTypes2.default.arrayOf(_propTypes2.default.string.isRequired).isRequired,
  cssImageZoomedInClass: _propTypes2.default.string,
  cssImageZoomedOutClass: _propTypes2.default.string
};


var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  frameHeight: 350,
  frameWidth: 250,
  itemWidth: 55,
  itemHeight: 80,

  srcs: (0, _from2.default)({ length: 8 }, function (_, i) {
    return 'https://loremflickr.com/210/300?random=' + i;
  }),
  zoomedInImageProps: {},
  zoomedOutImageProps: {
    style: {
      height: '30rem'
    }
  },
  cssImageZoomedOutClass: 'imageviewer__image--zoomed-out',
  cssImageZoomedInClass: 'imageviewer__image--zoomed-in'
}), (0, _recompose.withStateHandlers)(function (_ref3) {
  var srcs = _ref3.srcs;
  return { state: { activeSrc: srcs[0], isActive: false } };
}, {
  updateState: function updateState(_ref4) {
    var state = _ref4.state;
    return function (payload) {
      return { state: (0, _extends3.default)({}, state, payload) };
    };
  }
}));

exports.default = enhance(ImageViewer);