'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _recompose = require('recompose');

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _ResizeListener = require('./ResizeListener');

var _ResizeListener2 = _interopRequireDefault(_ResizeListener);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//write toggleModalIsOpen inside recompose handler
// adjust styling for 2+ steps
var MultiplePageModal = function MultiplePageModal(_ref) {
  var useStyleTemplate = _ref.useStyleTemplate,
      pageNavigationButtonsAreDisabled = _ref.pageNavigationButtonsAreDisabled,
      renderTrigger = _ref.renderTrigger,
      _ref$onMount = _ref.onMount,
      onMount = _ref$onMount === undefined ? function () {} : _ref$onMount,
      _ref$onUnmount = _ref.onUnmount,
      onUnmount = _ref$onUnmount === undefined ? function () {} : _ref$onUnmount,
      closeModalButtonIsRendered = _ref.closeModalButtonIsRendered,
      pages = _ref.pages,
      steps = _ref.steps,
      _ref$stepStyleConfig = _ref.stepStyleConfig,
      stepStyleConfig = _ref$stepStyleConfig === undefined ? {
    shared: {
      position: 'relative',
      display: 'flex',
      alignItems: 'center',
      cursor: 'pointer',
      height: '6rem',
      padding: '1rem 2rem'
    },
    inactive: {
      background: '#fff'
    },
    active: {
      background: '#eee'
    }
  } : _ref$stepStyleConfig,
      currentPage = _ref.currentPage,
      goToNextPage = _ref.goToNextPage,
      goToPreviousPage = _ref.goToPreviousPage,
      setCurrentPageTo = _ref.setCurrentPageTo,
      modalIsOpen = _ref.modalIsOpen,
      toggleModalIsOpen = _ref.toggleModalIsOpen,
      isTesting = _ref.isTesting,
      setModalIsOpenTo = _ref.setModalIsOpenTo,
      containerPropsOverride = _ref.containerPropsOverride,
      containerPropsAppend = _ref.containerPropsAppend,
      _ref$backgroundProps = _ref.backgroundProps,
      backgroundProps = _ref$backgroundProps === undefined ? {
    className: '',
    style: {}
  } : _ref$backgroundProps,
      renderNextButton = _ref.renderNextButton,
      renderBackButton = _ref.renderBackButton;

  var styleTemplate = useStyleTemplate ? _defaultStyles.modalStyleTemplates[useStyleTemplate] : {};
  var renderPageNavigationButtons = function renderPageNavigationButtons(_ref2) {
    var currentPage = _ref2.currentPage,
        length = _ref2.length,
        getButtonProps = _ref2.getButtonProps;

    var renderNext = function renderNext() {
      return renderNextButton({
        getButtonProps: getButtonProps,
        disabled: pageNavigationButtonsAreDisabled,
        goToNextPage: goToNextPage
      });
    };
    var renderBack = function renderBack() {
      return renderBackButton({ getButtonProps: getButtonProps, goToPreviousPage: goToPreviousPage });
    };
    if (currentPage === 0) {
      return renderNext();
    }
    if (currentPage === length - 1) {
      return renderBack();
    } else {
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        renderBack(),
        renderNext()
      );
    }
  };

  var renderSteps = function renderSteps(currentPageNumber, steps) {
    //const belowThreshold = window.innerWidth < 300 * steps.length
    //console.log(belowThreshold)

    return _react2.default.createElement(
      _ResizeListener2.default,
      { threshold: 300 * steps.length },
      function (_ref3) {
        var isOverThreshold = _ref3.isOverThreshold;
        return _react2.default.createElement(
          'div',
          {
            className: 'multiplepagemodal__steps',
            style: {
              display: 'flex',
              flexDirection: !isOverThreshold ? 'column' : 'row'
            }
          },
          steps.map(function (_ref4, stepNumber) {
            var renderStep = _ref4.renderStep;

            return _react2.default.createElement(_Step2.default, {
              onClick: function onClick() {
                return setCurrentPageTo(stepNumber);
              },
              belowThreshold: !isOverThreshold,
              stepStyleConfig: stepStyleConfig,
              key: stepNumber,
              isActive: currentPageNumber === stepNumber,
              isDisabled: stepNumber > currentPageNumber && pageNavigationButtonsAreDisabled,
              isComplete: currentPageNumber > stepNumber,
              isLast: stepNumber === steps.length - 1,
              renderStep: renderStep
            });
          })
        );
      }
    );
  };

  var getTriggerProps = function getTriggerProps() {
    var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref5.onClick,
        className = _ref5.className,
        props = (0, _objectWithoutProperties3.default)(_ref5, ['onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        toggleModalIsOpen();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__trigger ' + className : 'modal__trigger'

    }, props);
  };
  var getBackgroundProps = function getBackgroundProps() {
    var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick2 = _ref6.onClick,
        style = _ref6.style,
        className = _ref6.className,
        props = (0, _objectWithoutProperties3.default)(_ref6, ['onClick', 'style', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        setModalIsOpenTo(false);
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__background ' + className : 'modal__background',
      style: style
    }, props);
  };
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    renderTrigger && renderTrigger({ modalIsOpen: modalIsOpen, toggleModalIsOpen: toggleModalIsOpen, getTriggerProps: getTriggerProps }),
    _react2.default.createElement(
      _RTGTransition2.default,
      { in: isTesting ? true : modalIsOpen },
      function (_ref7) {
        var transitionStyle = _ref7.style;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getBackgroundProps({
            style: isTesting ? null : (0, _extends3.default)({}, transitionStyle, styleTemplate.background, backgroundProps.style),
            className: backgroundProps.className ? 'modal__background ' + backgroundProps.className : 'modal__background'
          })),
          pages.map(function (page, i) {
            return currentPage === i && _react2.default.createElement(_ModalDialog2.default, {
              useStyleTemplate: useStyleTemplate,
              onMount: onMount,
              onUnmount: onUnmount,
              key: currentPage,
              containerPropsOverride: containerPropsOverride,
              containerPropsAppend: containerPropsAppend,
              closeModalButtonIsRendered: closeModalButtonIsRendered,
              renderHeader: function renderHeader(_ref8) {
                var getHeaderProps = _ref8.getHeaderProps;
                return page.renderHeader ? page.renderHeader({ getHeaderProps: getHeaderProps, renderSteps: renderSteps(i, steps) }) : steps ? _react2.default.createElement(
                  'div',
                  getHeaderProps(),
                  renderSteps(i, steps)
                ) : null;
              },

              renderButtons: function renderButtons(_ref9) {
                var getButtonProps = _ref9.getButtonProps,
                    getButtonsProps = _ref9.getButtonsProps;
                return page.renderButtons ? page.renderButtons({
                  getButtonProps: getButtonProps,
                  getButtonsProps: getButtonsProps,
                  renderPageNavigationButtons: renderPageNavigationButtons({
                    currentPage: i,
                    length: pages.length,
                    getButtonProps: getButtonProps
                  })
                }) : _react2.default.createElement(
                  'div',
                  (0, _extends3.default)({}, getButtonsProps()),
                  renderPageNavigationButtons({
                    currentPage: i,
                    length: pages.length,
                    getButtonProps: getButtonProps
                  })
                );
              },

              renderBody: function renderBody(_ref10) {
                var getBodyProps = _ref10.getBodyProps;
                return page.renderBody ? page.renderBody({ getBodyProps: getBodyProps, setCurrentPageTo: setCurrentPageTo, toggleModalIsOpen: toggleModalIsOpen }) : _react2.default.createElement(
                  'div',
                  (0, _extends3.default)({}, getBodyProps()),
                  page.renderBody({ setCurrentPageTo: setCurrentPageTo, toggleModalIsOpen: toggleModalIsOpen })
                );
              },

              toggleModalIsOpen: toggleModalIsOpen
            });
          })
        );
      }
    )
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withState)('currentPage', 'setCurrentPageTo', 0), (0, _recompose.withHandlers)({
  toggleModalIsOpen: function toggleModalIsOpen(_ref11) {
    var setModalIsOpenTo = _ref11.setModalIsOpenTo;
    return function () {
      setModalIsOpenTo(function (x) {
        return !x;
      });
    };
  },
  goToNextPage: function goToNextPage(_ref12) {
    var setCurrentPageTo = _ref12.setCurrentPageTo,
        pages = _ref12.pages;
    return function () {
      setCurrentPageTo(function (n) {
        return n === pages.length - 1 ? n : n + 1;
      });
    };
  },
  goToPreviousPage: function goToPreviousPage(_ref13) {
    var setCurrentPageTo = _ref13.setCurrentPageTo;
    return function () {
      setCurrentPageTo(function (n) {
        return n === 0 ? n : n - 1;
      });
    };
  }
}), (0, _recompose.defaultProps)({
  useStyleTemplate: 'default'
}), (0, _recompose.setPropTypes)({
  pageNavigationButtonsAreDisabled: _propTypes2.default.bool,
  pages: _propTypes2.default.array.isRequired,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    renderStep: _propTypes2.default.func.isRequired
  })).isRequired,
  renderTrigger: _propTypes2.default.func.isRequired,
  closeModalButtonIsRendered: _propTypes2.default.bool,

  modalIsOpen: _propTypes2.default.bool.isRequired,
  currentPage: _propTypes2.default.number.isRequired,
  toggleModalIsOpen: _propTypes2.default.func.isRequired,
  setCurrentPageTo: _propTypes2.default.func.isRequired,
  goToNextPage: _propTypes2.default.func.isRequired,
  goToPreviousPage: _propTypes2.default.func.isRequired
}));

MultiplePageModal.defaultProps = {
  pageNavigationButtonsAreDisabled: false,
  renderNextButton: function renderNextButton(_ref14) {
    var getButtonProps = _ref14.getButtonProps,
        goToNextPage = _ref14.goToNextPage,
        disabled = _ref14.disabled;
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends3.default)({}, getButtonProps({ onClick: goToNextPage }), { disabled: disabled }),
      'NEXT'
    );
  },
  renderBackButton: function renderBackButton(_ref15) {
    var getButtonProps = _ref15.getButtonProps,
        goToPreviousPage = _ref15.goToPreviousPage;
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends3.default)({}, getButtonProps({ onClick: goToPreviousPage })),
      'BACK'
    );
  }
};

exports.default = enhance(MultiplePageModal);