'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMany = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _defaultStyles = require('./defaultStyles');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { Button } from './Button'

var SelectMany = function SelectMany(_ref) {
  var sortingFunction = _ref.sortingFunction,
      _ref$showUnselectedOn = _ref.showUnselectedOnly,
      showUnselectedOnly = _ref$showUnselectedOn === undefined ? false : _ref$showUnselectedOn,
      children = _ref.children,
      clearCurrent = _ref.clearCurrent,
      onChange = _ref.onChange,
      renderTrigger = _ref.renderTrigger,
      currentOptions = _ref.currentOptions,
      addToCurrentOptions = _ref.addToCurrentOptions,
      removeFromCurrentOptions = _ref.removeFromCurrentOptions,
      props = (0, _objectWithoutProperties3.default)(_ref, ['sortingFunction', 'showUnselectedOnly', 'children', 'clearCurrent', 'onChange', 'renderTrigger', 'currentOptions', 'addToCurrentOptions', 'removeFromCurrentOptions']);

  var isActive = function isActive(option) {
    return currentOptions.some(function (currentOption) {
      return currentOption.value === option.value;
    });
  };
  var getChildProps = function getChildProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        if (isActive(option)) {
          removeFromCurrentOptions(option);
          onChange(currentOptions.filter(function (currentOption) {
            return currentOption.value !== option.value;
          }));
        } else {
          addToCurrentOptions(option);
          if (sortingFunction) {
            onChange([].concat((0, _toConsumableArray3.default)(currentOptions), [option]).sort(sortingFunction));
          } else {
            onChange([].concat((0, _toConsumableArray3.default)(currentOptions), [option]));
          }
        }
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), 'selectmany__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : ''),
      style: style
    }, props);
  };

  var handleRenderTrigger = function handleRenderTrigger(_ref3) {
    var isOn = _ref3.isOn,
        _getTriggerProps = _ref3.getTriggerProps;
    return renderTrigger ? renderTrigger({
      currentOptions: currentOptions,
      isOn: isOn,
      getTriggerProps: function getTriggerProps() {
        var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var _ref4$className = _ref4.className,
            className = _ref4$className === undefined ? '' : _ref4$className,
            props = (0, _objectWithoutProperties3.default)(_ref4, ['className']);
        return _getTriggerProps((0, _extends3.default)({
          className: 'selectmany__trigger ' + className
        }, props));
      }
    }) : _react2.default.createElement(
      _Button2.default,
      {
        type: 'caretdropdown',
        isOn: isOn,
        colors: _defaultStyles.buttonStyles.mild
      },
      function (_ref5) {
        var getButtonProps = _ref5.getButtonProps,
            icon = _ref5.icon;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({}, _getTriggerProps({
            className: 'selectmany__trigger',
            style: {
              display: 'flex',
              justifyContent: 'space-between'
            }
          })))),
          _react2.default.createElement(
            'div',
            {
              className: 'selectmany__options',
              style: {
                display: 'flex',
                flexWrap: 'wrap'
              }
            },
            currentOptions.length > 0 ? currentOptions.map(function (option, i) {
              return _react2.default.createElement(
                'div',
                {
                  key: '' + option.value + i,
                  style: {
                    className: 'selectmany__option',
                    display: 'flex',
                    background: '#f3f3f3',
                    borderRadius: '0.25rem',
                    margin: '0.25rem 0.375rem'
                  }
                },
                _react2.default.createElement(
                  'div',
                  {
                    className: 'selectmany__option__label',
                    style: {
                      display: 'flex',
                      alignItems: 'center',
                      color: '#2b2b2b',
                      padding: '0.25rem 0.375rem'
                    }
                  },
                  option.label
                ),
                _react2.default.createElement(_Button2.default, {
                  className: 'selectmany__option__remove',
                  type: 'cancel',
                  colors: _defaultStyles.buttonStyles.redden,
                  onClick: function onClick() {
                    removeFromCurrentOptions(option);
                  }
                })
              );
            }) : _react2.default.createElement(
              'div',
              {
                className: 'selectmany__guide',
                style: {
                  display: 'flex',
                  borderRadius: '0.25rem',
                  margin: '0.25rem 0.375rem'
                }
              },
              'select one...'
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'selectmany__removall', style: { display: 'flex' } },
            currentOptions.length > 0 && _react2.default.createElement(_Button2.default, {
              type: 'cancel',
              colors: _defaultStyles.buttonStyles.redden,
              onClick: function onClick() {
                clearCurrent();
              }
            }),
            _react2.default.createElement(
              'div',
              { className: 'selectmany__caret', style: { padding: '0.5rem 0.75rem' } },
              icon
            )
          )
        );
      }
    );
  };
  return _react2.default.createElement(
    _CTCPopover2.default,
    (0, _extends3.default)({
      renderTrigger: handleRenderTrigger
    }, props),
    function (_ref6) {
      var getChildrenProps = _ref6.getChildrenProps,
          toggleIsOn = _ref6.toggleIsOn;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        getChildrenProps: getChildrenProps,
        toggleIsOn: toggleIsOn,
        currentOptions: currentOptions
      }) : _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getChildrenProps({ style: { zIndex: 1 } })),
        children.filter(function (option) {
          if (showUnselectedOnly) {
            if (!currentOptions.some(function (currentOption) {
              return currentOption.value === option.value;
            })) {
              return option;
            }
          } else {
            return option;
          }
        }).map(function (option) {
          return _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getChildProps({ option: option }), {
              colors: _defaultStyles.buttonStyles.monochrome,
              isOn: currentOptions.some(function (currentOption) {
                return currentOption.value === option.value;
              }),
              key: option.value
            }),
            option.label
          );
        })
      );
    }
  );
};

exports.SelectMany = SelectMany;
SelectMany.propTypes = {};
SelectMany.defaultProps = {
  onChange: function onChange(x) {
    return console.log(x);
  },
  buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('currentOptions', 'setCurrentOptions', function (_ref7) {
  var _ref7$currentOptions = _ref7.currentOptions,
      currentOptions = _ref7$currentOptions === undefined ? [] : _ref7$currentOptions;
  return currentOptions;
}), (0, _recompose.withHandlers)({
  addToCurrentOptions: function addToCurrentOptions(_ref8) {
    var setCurrentOptions = _ref8.setCurrentOptions,
        sortingFunction = _ref8.sortingFunction;
    return function (option) {
      if (sortingFunction) {
        setCurrentOptions(function (x) {
          return [].concat((0, _toConsumableArray3.default)(x), [option]).sort(sortingFunction);
        });
      } else {
        setCurrentOptions(function (x) {
          return [].concat((0, _toConsumableArray3.default)(x), [option]);
        });
      }
    };
  },
  removeFromCurrentOptions: function removeFromCurrentOptions(_ref9) {
    var setCurrentOptions = _ref9.setCurrentOptions;
    return function (option) {
      return setCurrentOptions(function (currentOptions) {
        return currentOptions.filter(function (currentOption) {
          return currentOption.value !== option.value;
        });
      });
    };
  },
  clearCurrent: function clearCurrent(_ref10) {
    var setCurrentOptions = _ref10.setCurrentOptions;
    return function () {
      return setCurrentOptions([]);
    };
  }
}));

exports.default = enhance(SelectMany);