'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectOne = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _CTCPopover = require('./CTCPopover');

var _CTCPopover2 = _interopRequireDefault(_CTCPopover);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectOne = function SelectOne(_ref) {
  var onChange = _ref.onChange,
      children = _ref.children,
      _renderTrigger = _ref.renderTrigger,
      currentOption = _ref.currentOption,
      setCurrentOption = _ref.setCurrentOption,
      _ref$showCurrentOptio = _ref.showCurrentOption,
      showCurrentOption = _ref$showCurrentOptio === undefined ? false : _ref$showCurrentOptio,
      options = _ref.options,
      props = (0, _objectWithoutProperties3.default)(_ref, ['onChange', 'children', 'renderTrigger', 'currentOption', 'setCurrentOption', 'showCurrentOption', 'options']);

  var getChildProps = function getChildProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

    var isActive = function isActive(option) {
      return option.value === currentOption.value;
    };
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        setCurrentOption(option);
        onChange(option);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: (0, _helperFunctions.flippyClass)(isActive(option), 'selectone__option', 'active', 'inactive') + ' ' + (className ? (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : ''),
      style: (0, _extends3.default)({
        display: showCurrentOption === false && isActive(option) ? 'none' : 'flex'

      }, style)
    }, props);
  };
  return _react2.default.createElement(
    _CTCPopover2.default,
    (0, _extends3.default)({
      renderTrigger: function renderTrigger(_ref3) {
        var isOn = _ref3.isOn,
            _getTriggerProps = _ref3.getTriggerProps;
        return _renderTrigger ? _renderTrigger({
          currentOption: currentOption,
          isOn: isOn,
          getTriggerProps: function getTriggerProps() {
            var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var className = _ref4.className,
                props = (0, _objectWithoutProperties3.default)(_ref4, ['className']);
            return _getTriggerProps((0, _extends3.default)({
              className: 'selectone__trigger ' + (className ? className : '')
            }, props));
          }
        }) : _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            type: 'caretdropdown',
            isOn: isOn
          }, _getTriggerProps({
            className: 'selectone__trigger'
          }), {
            colors: _defaultStyles.buttonStyles.monochrome
          }),
          currentOption ? currentOption.label : options[0].label
        );
      }
    }, props),
    function (_ref5) {
      var getChildrenProps = _ref5.getChildrenProps,
          isOn = _ref5.isOn,
          setIsOnTo = _ref5.setIsOnTo,
          toggleIsOn = _ref5.toggleIsOn;
      return typeof children === 'function' ? children({
        getChildProps: getChildProps,
        getChildrenProps: getChildrenProps,
        isOn: isOn,
        setIsOnTo: setIsOnTo,
        toggleIsOn: toggleIsOn,
        currentOption: currentOption
      }) : _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, getChildrenProps({ style: { height: '20rem', overflowY: 'scroll' } })),
        children.map(function (option) {
          return _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({}, getChildProps({
              option: { value: option.value, label: option.label },
              onClick: toggleIsOn
            }), {

              colors: _defaultStyles.buttonStyles.monochrome,
              isOn: currentOption.value === option.value,
              key: option.value
            }),
            option.label
          );
        })
      );
    }
  );
};

exports.SelectOne = SelectOne;
SelectOne.propTypes = {};
SelectOne.defaultProps = {
  buttonType: 'select--default'
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('currentOption', 'setCurrentOption', function (_ref6) {
  var currentOption = _ref6.currentOption,
      options = _ref6.options;
  return currentOption ? currentOption : options[0];
}));

exports.default = enhance(SelectOne);