'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _MQLListener = require('./MQLListener');

var _MQLListener2 = _interopRequireDefault(_MQLListener);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseImageStyle = {
  gridArea: 'image',
  display: 'flex',
  flexDirection: 'column',
  justifyContent: 'center',
  alignItems: 'center'
};
var baseBeltStyle = {
  gridArea: 'belt'
};

var baseNavStyle = {
  justifyContent: 'center',
  alignItems: 'center',
  display: 'flex',
  cursor: 'pointer'
};

var baseInfoStyle = {
  gridArea: 'info',
  flexDirection: 'column',
  justifyContent: 'space-between',
  display: 'flex'
};
var baseContainerStyle = {
  display: 'grid'
};

var Showcase = function Showcase(_ref) {
  var updateState = _ref.updateState,
      _ref$state = _ref.state,
      activeId = _ref$state.activeId,
      beltIsRendered = _ref$state.beltIsRendered,
      items = _ref.items,
      children = _ref.children;

  var ids = items.map(function (item) {
    return item.id;
  });
  var nextId = ids.indexOf(activeId) === 0 ? ids[ids.length - 1] : ids[ids.indexOf(activeId) - 1];
  var prevId = ids.indexOf(activeId) === ids.length - 1 ? ids[0] : ids[ids.indexOf(activeId) + 1];
  var nextItem = items.find(function (item) {
    return item.id === nextId;
  });
  var prevItem = items.find(function (item) {
    return item.id === prevId;
  });

  var getContainerProps = function getContainerProps(_ref2) {
    var style = _ref2.style,
        className = _ref2.className,
        _onClick = _ref2.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['style', 'className', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseContainerStyle, style),
      className: className ? className + ' showcase__container' : 'showcase__container',
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getImageProps = function getImageProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref3.style,
        className = _ref3.className,
        _onClick2 = _ref3.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['style', 'className', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseImageStyle, style),
      className: className ? className + ' showcase__image' : 'showcase__image',
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getInfoProps = function getInfoProps() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref4.style,
        className = _ref4.className,
        _onClick3 = _ref4.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref4, ['style', 'className', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseInfoStyle, style),
      className: className ? className + ' showcase__info' : 'showcase__info',
      onClick: function onClick(e) {
        for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        e.stopPropagation();
        _onClick3 && _onClick3.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getBeltProps = function getBeltProps() {
    var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref5.style,
        className = _ref5.className,
        _onClick4 = _ref5.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref5, ['style', 'className', 'onClick']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseBeltStyle, style),
      className: className ? className + ' showcase__belt' : 'showcase__belt',
      onClick: function onClick(e) {
        for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        e.stopPropagation();
        _onClick4 && _onClick4.apply(undefined, [e].concat(args));
      }
    }, props);
  };
  var getNavProps = function getNavProps() {
    var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref6.style,
        className = _ref6.className,
        _onClick5 = _ref6.onClick,
        cardinal = _ref6.cardinal,
        props = (0, _objectWithoutProperties3.default)(_ref6, ['style', 'className', 'onClick', 'cardinal']);
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, baseNavStyle, { gridArea: cardinal + '-nav' }, style),
      className: className ? className + ' showcase__nav showcase__' + cardinal + '-nav' : 'showcase__nav showcase__' + cardinal + '-nav',
      onClick: function onClick(e) {
        for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
          args[_key5 - 1] = arguments[_key5];
        }

        e.stopPropagation();
        if (cardinal === 'w') {
          updateState({ activeId: prevId });
        }
        if (cardinal === 'e') {
          updateState({ activeId: nextId });
        }
        _onClick5 && _onClick5.apply(undefined, [e].concat(args));
      }
    }, props);
  };

  return _react2.default.createElement(
    _MQLListener2.default,
    { widthThreshold: 750 },
    function (_ref7) {
      var matches = _ref7.matches;
      return _react2.default.createElement(
        _react.Fragment,
        null,
        items.map(function (item, i) {
          return console.log(item) || item.id === activeId ? _react2.default.createElement(
            _react.Fragment,
            { key: i },
            children({
              isSmall: matches,
              mqStyle: !matches ? {
                gridTemplateColumns: '1fr 320px 400px 1fr',
                gridTemplateRows: '40px 13.25rem auto auto 40px auto auto',
                gridTemplateAreas: '                      \n                      \'nw n-nav n-nav ne\'\n                      \'w-nav image info e-nav\'\n                      \'w-nav image info e-nav\'\n                      \'w-nav image info e-nav\'\n                      \'sw s-nav s-nav se\'\n                      \'belt belt belt belt\'\n                    '
              } : {
                gridTemplateColumns: '1fr 240px 1fr',
                gridTemplateRows: '40px auto 40px auto auto auto auto auto',
                gridTemplateAreas: '                      \n                      \'nw n-nav ne\'\n                      \'w-nav image e-nav\'\n                      \'sw s-nav se\'\n                      \'info info info\'\n                      \'belt belt belt\'\n                    '
              },
              getContainerProps: getContainerProps,
              getImageProps: getImageProps,
              getBeltProps: getBeltProps,
              getNavProps: getNavProps,
              getInfoProps: getInfoProps,
              beltIsRendered: beltIsRendered,
              updateState: updateState,
              item: item,
              nextItem: nextItem,
              prevItem: prevItem
            })
          ) : null;
        })
      );
    }
  );
};

Showcase.propTypes = {};

var enhance = (0, _recompose.compose)((0, _recompose.withStateHandlers)(function (_ref8) {
  var items = _ref8.items;
  return { state: { activeId: items[0].id, beltIsRendered: true } };
}, {
  updateState: function updateState(_ref9) {
    var state = _ref9.state;
    return function (payload) {
      return { state: (0, _extends3.default)({}, state, payload) };
    };
  }
}));
//  onlyUpdateForKeys([``])

exports.default = enhance(Showcase);