'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SinglePageModal = function SinglePageModal(_ref) {
  var _ref$demoModeIsOn = _ref.demoModeIsOn,
      demoModeIsOn = _ref$demoModeIsOn === undefined ? false : _ref$demoModeIsOn,
      style = _ref.style,
      className = _ref.className,
      onClick = _ref.onClick,
      onMount = _ref.onMount,
      onUnmount = _ref.onUnmount,
      children = _ref.children,
      renderTrigger = _ref.renderTrigger,
      defaultCloseModalButton = _ref.defaultCloseModalButton,
      renderCloseModalButton = _ref.renderCloseModalButton,
      renderHeader = _ref.renderHeader,
      dataTestId = _ref.dataTestId,
      renderBody = _ref.renderBody,
      modalIsOpen = _ref.modalIsOpen,
      setModalIsOpenTo = _ref.setModalIsOpenTo,
      toggleModalIsOpen = _ref.toggleModalIsOpen,
      openModal = _ref.openModal,
      closeModal = _ref.closeModal,
      renderButtons = _ref.renderButtons,
      useStyleTemplate = _ref.useStyleTemplate,
      backgroundProps = _ref.backgroundProps;

  var styleTemplate = useStyleTemplate ? _defaultStyles.modalStyleTemplates[useStyleTemplate] : {};
  var getTriggerProps = function getTriggerProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var style = _ref2.style,
        _onClick = _ref2.onClick,
        className = _ref2.className,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['style', 'onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        openModal();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__trigger ' + className : 'modal__trigger',
      style: style
    }, props);
  };
  var getBackgroundProps = function getBackgroundProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick2 = _ref3.onClick,
        style = _ref3.style,
        className = _ref3.className,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'style', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        closeModal(), _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__background ' + className : 'modal__background',
      style: (0, _extends3.default)({}, styleTemplate.background, style)
    }, props);
  };
  var renderModalDialog = function renderModalDialog() {
    return _react2.default.createElement(_ModalDialog2.default, {
      style: style,
      className: className,
      onClick: onClick,
      onMount: onMount,
      onUnmount: onUnmount,
      dataTestId: dataTestId,
      defaultCloseModalButton: defaultCloseModalButton,
      renderHeader: renderHeader,
      renderBody: renderBody ? renderBody : children,
      closeModal: closeModal,
      toggleModalIsOpen: toggleModalIsOpen,
      renderButtons: renderButtons,
      renderCloseModalButton: renderCloseModalButton,
      useStyleTemplate: useStyleTemplate,
      setModalIsOpenTo: setModalIsOpenTo
    });
  };
  return _react2.default.createElement(
    _react.Fragment,
    null,
    renderTrigger && renderTrigger({ getTriggerProps: getTriggerProps }),
    demoModeIsOn && renderModalDialog(),
    _react2.default.createElement(
      _RTGTransition2.default,
      { in: modalIsOpen },
      function (_ref4) {
        var transitionStyle = _ref4.style;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getBackgroundProps({
            style: (0, _extends3.default)({}, transitionStyle, backgroundProps.style),
            className: backgroundProps.className
          })),
          renderModalDialog()
        );
      }
    )
  );
};

SinglePageModal.defaultProps = {};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  defaultCloseModalButton: true,
  onCloseModal: function onCloseModal() {
    return null;
  },
  onOpenModal: function onOpenModal() {
    return null;
  }
}), (0, _recompose.withState)('modalIsOpen', 'setModalIsOpenTo', false), (0, _recompose.withHandlers)({
  closeModal: function closeModal(_ref5) {
    var setModalIsOpenTo = _ref5.setModalIsOpenTo,
        onCloseModal = _ref5.onCloseModal;
    return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return onCloseModal();

            case 2:
              setModalIsOpenTo(false);

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));
  },
  openModal: function openModal(_ref7) {
    var setModalIsOpenTo = _ref7.setModalIsOpenTo,
        onOpenModal = _ref7.onOpenModal;
    return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return onOpenModal();

            case 2:
              setModalIsOpenTo(true);

            case 3:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));
  },
  toggleModalIsOpen: function toggleModalIsOpen(_ref9) {
    var setModalIsOpenTo = _ref9.setModalIsOpenTo,
        modalIsOpen = _ref9.modalIsOpen;
    return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              ;_context3.next = 3;
              return modalIsOpen;

            case 3:
              if (!_context3.sent) {
                _context3.next = 7;
                break;
              }

              onCloseModal();
              _context3.next = 8;
              break;

            case 7:
              onOpenModal();

            case 8:
              setModalIsOpenTo(function (x) {
                return !x;
              });

            case 9:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));
  }
}), (0, _recompose.defaultProps)({
  onMount: function onMount() {},
  onUnmount: function onUnmount() {},
  useStyleTemplate: 'default',
  backgroundProps: {}
}), (0, _recompose.setPropTypes)({
  modalIsOpen: _propTypes2.default.bool.isRequired,
  toggleModalIsOpen: _propTypes2.default.func.isRequired
}));

exports.default = enhance(SinglePageModal);