'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _defaultStyles = require('./defaultStyles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Switch = function Switch(_ref) {
  var children = _ref.children,
      activeOption = _ref.activeOption,
      setActiveOption = _ref.setActiveOption,
      useStyleTemplate = _ref.useStyleTemplate,
      transitionType = _ref.transitionType;

  var styleTemplate = useStyleTemplate ? _defaultStyles.switchStyleTemplates[useStyleTemplate] : {};
  var isActive = function isActive(option) {
    return activeOption === option;
  };
  var getOptionProps = function getOptionProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        option = _ref2.option,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation;
        setActiveOption(option);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option', 'active', 'inactive') + ' ' + className : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option', 'active', 'inactive'),
      style: (0, _extends3.default)({}, styleTemplate.option, style)
    }, props);
  };

  var renderContent = function renderContent(func, option) {
    return _react2.default.createElement(
      _RTGTransition2.default,
      { in: isActive(option), transitionType: transitionType },
      function (_ref3) {
        var transitionStyle = _ref3.style;

        var getContentProps = function getContentProps() {
          var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          var className = _ref4.className,
              _ref4$style = _ref4.style,
              style = _ref4$style === undefined ? {} : _ref4$style,
              _onClick2 = _ref4.onClick,
              option = _ref4.option,
              props = (0, _objectWithoutProperties3.default)(_ref4, ['className', 'style', 'onClick', 'option']);

          return (0, _extends3.default)({
            onClick: function onClick(e) {
              for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
              }

              e.stopPropagation;
              _onClick2 && _onClick2.apply(undefined, [e].concat(args));
            },
            className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') + ' ' + className : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive'),
            style: (0, _extends3.default)({}, styleTemplate.option, transitionStyle, style)
          }, props);
        };
        return func({ getContentProps: getContentProps });
      }
    );
  };
  var getLabelProps = function getLabelProps() {
    var _ref5 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref5.className,
        style = _ref5.style,
        _onClick3 = _ref5.onClick,
        option = _ref5.option,
        props = (0, _objectWithoutProperties3.default)(_ref5, ['className', 'style', 'onClick', 'option']);

    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        e.stopPropagation;
        _onClick3 && _onClick3.apply(undefined, [e].concat(args));
      },
      className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') + ' ' + className : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive')

    }, props);
  };

  return children({ getOptionProps: getOptionProps, renderContent: renderContent, getLabelProps: getLabelProps, activeOption: activeOption, isActive: isActive });
};
// import {connect} from 'react-redux'


Switch.propTypes = {
  children: _propTypes2.default.func.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({ useStyleTemplate: 'default' }), (0, _recompose.withStateHandlers)(function (_ref6) {
  var _ref6$defaultValue = _ref6.defaultValue,
      defaultValue = _ref6$defaultValue === undefined ? '0' : _ref6$defaultValue;
  return { activeOption: defaultValue };
}, {
  setActiveOption: function setActiveOption() {
    return function (value) {
      return { activeOption: value };
    };
  }
}));

exports.default = enhance(Switch);